package org.fuseri.moduleexercise.exercise;

import org.fuseri.model.dto.exercise.ExerciseCreateDto;
import org.fuseri.model.dto.exercise.ExerciseDto;
import org.fuseri.moduleexercise.common.DomainMapper;
import org.mapstruct.Mapper;

/**
 * Mapper between Exercises and their corresponding DTOs
 */
@Mapper
public interface ExerciseMapper extends DomainMapper<Exercise, ExerciseDto> {

    /**
     * Convert DTO of type ExerciseCreateDto to Exercise
     *
     * @param dto DTO to be converted
     * @return corresponding Exercise entity created from DTO
     */
    Exercise fromCreateDto(ExerciseCreateDto dto);
}
