package org.fuseri.modulelanguageschool.lecture;

import jakarta.persistence.Entity;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.fuseri.modulelanguageschool.common.DomainObject;
import org.fuseri.modulelanguageschool.course.Course;
import org.fuseri.modulelanguageschool.user.User;

import java.time.LocalDateTime;
import java.util.Set;

/**
 * This class represents a lecture entity in the domain model.
 */
@Getter
@Setter
@Entity
@Table(name = "lecture")
@NoArgsConstructor
@AllArgsConstructor
public class Lecture extends DomainObject {

    private LocalDateTime from;
    private LocalDateTime to;
    private String topic;

    @ManyToOne
    private Course course;

    @ManyToOne
    private User lecturer;

    @ManyToMany
    private Set<User> students;

    public void enrolStudent(User student) {
        students.add(student);
    }

    public void expelStudent(User student) {
        students.remove(student);
    }
}
