package org.fuseri.modulelanguageschool.lecture;

import org.fuseri.model.dto.lecture.LectureCreateDto;
import org.fuseri.model.dto.lecture.LectureDto;
import org.mapstruct.Mapper;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import java.util.List;

@Mapper(componentModel = "spring")
public interface LectureMapper {
    LectureDto mapToDto(Lecture lecture);

    Lecture mapToLecture(LectureDto lectureDto);

    List<LectureDto> mapToList(List<Lecture> lectures);


    default Page<LectureDto> mapToPageDto(Page<Lecture> lectures) {
        return new PageImpl<>(mapToList(lectures.getContent()), lectures.getPageable(), lectures.getTotalPages());
    }

    Lecture mapToLecture(LectureCreateDto dto);
}
